Index: /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/ArtificialAnt/Interpreter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/ArtificialAnt/Interpreter.cs	(revision 13268)
+++ /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/ArtificialAnt/Interpreter.cs	(revision 13269)
@@ -32,9 +32,8 @@
     public int FoodEaten { get; private set; }
     public BoolMatrix World { get; private set; }
-
     public ISymbolicExpressionTree Expression { get; private set; }
 
+    public int ElapsedTime { get; set; }
 
-    public int ElapsedTime { get; set; }
     private int currentDirection;
     private int currentAntLocationRow;
Index: /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/ArtificialAnt/Problem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/ArtificialAnt/Problem.cs	(revision 13268)
+++ /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/ArtificialAnt/Problem.cs	(revision 13269)
@@ -22,5 +22,4 @@
 using System;
 using System.Diagnostics.Contracts;
-using System.Drawing.Text;
 using System.Linq;
 using HeuristicLab.Common;
@@ -103,4 +102,18 @@
     }
 
+    #region item cloning and persistence
+    // persistence
+    [StorableConstructor]
+    private Problem(bool deserializing) : base(deserializing) { }
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() { }
+
+    // cloning 
+    private Problem(Problem original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new Problem(this, cloner);
+    }
+    #endregion
+
     public Problem()
       : base() {
@@ -136,19 +149,4 @@
     }
 
-    // persistence
-    [StorableConstructor]
-    private Problem(bool deserializing) : base(deserializing) { }
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-    }
-
-    // cloning 
-    private Problem(Problem original, Cloner cloner)
-      : base(original, cloner) {
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new Problem(this, cloner);
-    }
-
     #region helpers
     private bool[,] ToBoolMatrix(char[][] ch) {
Index: /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/ArtificialAnt/Trail.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/ArtificialAnt/Trail.cs	(revision 13268)
+++ /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/ArtificialAnt/Trail.cs	(revision 13269)
@@ -20,5 +20,4 @@
 #endregion
 
-using System;
 using System.Drawing;
 using HeuristicLab.Common;
@@ -54,4 +53,5 @@
     }
 
+    #region item cloning and persistence
     [StorableConstructor]
     private Solution(bool deserializing) : base(deserializing) { }
@@ -70,4 +70,5 @@
       return new Solution(this, cloner);
     }
+    #endregion
   }
 }
Index: /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/BasicSymbolicRegression/Problem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/BasicSymbolicRegression/Problem.cs	(revision 13268)
+++ /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/BasicSymbolicRegression/Problem.cs	(revision 13269)
@@ -39,10 +39,6 @@
 
     #region parameter names
-
     private const string ProblemDataParameterName = "ProblemData";
-
     #endregion
-
-    public event EventHandler ProblemDataChanged;
 
     #region Parameter Properties
@@ -52,9 +48,7 @@
       get { return (IValueParameter<IRegressionProblemData>)Parameters[ProblemDataParameterName]; }
     }
-
     #endregion
 
     #region Properties
-
     public IRegressionProblemData ProblemData {
       get { return ProblemDataParameter.Value; }
@@ -62,11 +56,28 @@
     }
     IDataAnalysisProblemData IDataAnalysisProblem.ProblemData { get { return ProblemData; } }
+    #endregion
 
-
-    #endregion
+    public event EventHandler ProblemDataChanged;
 
     public override bool Maximization {
       get { return true; }
     }
+
+    #region item cloning and persistence
+    // persistence
+    [StorableConstructor]
+    private Problem(bool deserializing) : base(deserializing) { }
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      RegisterEventHandlers();
+    }
+
+    // cloning 
+    private Problem(Problem original, Cloner cloner)
+      : base(original, cloner) {
+      RegisterEventHandlers();
+    }
+    public override IDeepCloneable Clone(Cloner cloner) { return new Problem(this, cloner); }
+    #endregion
 
     public Problem()
@@ -102,8 +113,8 @@
       return InterpretRec(tree.Root.GetSubtree(0).GetSubtree(0), dataset, rows);
     }
-                                                                                                       
+
     private IEnumerable<double> InterpretRec(ISymbolicExpressionTreeNode node, IDataset dataset, IEnumerable<int> rows) {
       Func<ISymbolicExpressionTreeNode, ISymbolicExpressionTreeNode, Func<double, double, double>, IEnumerable<double>> binaryEval =
-        (left, right, f) => InterpretRec(left, dataset,rows).Zip(InterpretRec(right, dataset, rows), f);
+        (left, right, f) => InterpretRec(left, dataset, rows).Zip(InterpretRec(right, dataset, rows), f);
 
       switch (node.Symbol.Name) {
@@ -124,26 +135,6 @@
     }
 
-    #region item cloning and persistence
-    // persistence
-    [StorableConstructor]
-    private Problem(bool deserializing) : base(deserializing) { }
-
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-      RegisterEventHandlers();
-    }
-
-    // cloning 
-    private Problem(Problem original, Cloner cloner)
-      : base(original, cloner) {
-      RegisterEventHandlers();
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new Problem(this, cloner);
-    }
-    #endregion
 
     #region events
-
     private void RegisterEventHandlers() {
       ProblemDataParameter.ValueChanged += new EventHandler(ProblemDataParameter_ValueChanged);
@@ -188,5 +179,4 @@
       Encoding.Grammar = g;
     }
-
     #endregion
 
Index: /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/Boolean/EvenParityProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/Boolean/EvenParityProblem.cs	(revision 13268)
+++ /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/Boolean/EvenParityProblem.cs	(revision 13269)
@@ -58,4 +58,23 @@
     }
 
+    #region item cloning and persistence
+    // persistence
+    [StorableConstructor]
+    private EvenParityProblem(bool deserializing) : base(deserializing) { }
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      RegisterEventHandlers();
+    }
+
+    // cloning 
+    private EvenParityProblem(EvenParityProblem original, Cloner cloner)
+      : base(original, cloner) {
+      RegisterEventHandlers();
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new EvenParityProblem(this, cloner);
+    }
+    #endregion
+
     public EvenParityProblem()
       : base() {
@@ -109,8 +128,8 @@
 
       switch (node.Symbol.Name) {
-        case "AND":  return binaryEval(node.GetSubtree(0), node.GetSubtree(1), (x, y) => x & y);
-        case "OR":   return binaryEval(node.GetSubtree(0), node.GetSubtree(1), (x, y) => x | y);
+        case "AND": return binaryEval(node.GetSubtree(0), node.GetSubtree(1), (x, y) => x & y);
+        case "OR": return binaryEval(node.GetSubtree(0), node.GetSubtree(1), (x, y) => x | y);
         case "NAND": return binaryEval(node.GetSubtree(0), node.GetSubtree(1), (x, y) => !(x & y));
-        case "NOR":  return binaryEval(node.GetSubtree(0), node.GetSubtree(1), (x, y) => !(x | y));
+        case "NOR": return binaryEval(node.GetSubtree(0), node.GetSubtree(1), (x, y) => !(x | y));
         default: {
             byte bitPos;
@@ -126,24 +145,4 @@
     }
 
-    #region item cloning and persistence
-    // persistence
-    [StorableConstructor]
-    private EvenParityProblem(bool deserializing) : base(deserializing) { }
-
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-      RegisterEventHandlers();
-    }
-
-    // cloning 
-    private EvenParityProblem(EvenParityProblem original, Cloner cloner)
-      : base(original, cloner) {
-      RegisterEventHandlers();
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new EvenParityProblem(this, cloner);
-    }
-    #endregion
-
     #region events
     private void RegisterEventHandlers() {
Index: /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/Boolean/MultiplexerProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/Boolean/MultiplexerProblem.cs	(revision 13268)
+++ /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/Boolean/MultiplexerProblem.cs	(revision 13269)
@@ -59,4 +59,24 @@
       get { return true; }
     }
+
+    #region item cloning and persistence
+    // persistence
+    [StorableConstructor]
+    private MultiplexerProblem(bool deserializing) : base(deserializing) { }
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      RegisterEventHandlers();
+    }
+
+    // cloning 
+    private MultiplexerProblem(MultiplexerProblem original, Cloner cloner)
+      : base(original, cloner) {
+      RegisterEventHandlers();
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MultiplexerProblem(this, cloner);
+    }
+    #endregion
+
 
     public MultiplexerProblem()
@@ -134,7 +154,7 @@
       switch (node.Symbol.Name) {
         case "AND": return binaryEval(node.GetSubtree(0), node.GetSubtree(1), (x, y) => x & y);
-        case "OR":  return binaryEval(node.GetSubtree(0), node.GetSubtree(1), (x, y) => x | y);
+        case "OR": return binaryEval(node.GetSubtree(0), node.GetSubtree(1), (x, y) => x | y);
         case "NOT": return unaryEval(node.GetSubtree(0), (x) => !x);
-        case "IF":  return EvalIf(node.GetSubtree(0), node.GetSubtree(1), node.GetSubtree(2), bs, addrBits);
+        case "IF": return EvalIf(node.GetSubtree(0), node.GetSubtree(1), node.GetSubtree(2), bs, addrBits);
         default: {
             if (node.Symbol.Name[0] == 'a') {
@@ -171,24 +191,4 @@
     }
 
-    #region item cloning and persistence
-    // persistence
-    [StorableConstructor]
-    private MultiplexerProblem(bool deserializing) : base(deserializing) { }
-
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-      RegisterEventHandlers();
-    }
-
-    // cloning 
-    private MultiplexerProblem(MultiplexerProblem original, Cloner cloner)
-      : base(original, cloner) {
-      RegisterEventHandlers();
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new MultiplexerProblem(this, cloner);
-    }
-    #endregion
-
     #region events
     private void RegisterEventHandlers() {
Index: /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/LawnMower/Problem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/LawnMower/Problem.cs	(revision 13268)
+++ /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/LawnMower/Problem.cs	(revision 13269)
@@ -50,4 +50,5 @@
     }
 
+    #region item cloning and persistence
     [StorableConstructor]
     protected Problem(bool deserializing) : base(deserializing) { }
@@ -59,4 +60,5 @@
       return new Problem(this, cloner);
     }
+    #endregion
 
     public Problem()
Index: /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/LawnMower/Solution.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/LawnMower/Solution.cs	(revision 13268)
+++ /trunk/sources/HeuristicLab.Problems.GeneticProgramming/3.3/LawnMower/Solution.cs	(revision 13269)
@@ -37,4 +37,5 @@
     public double Quality { get; private set; }
 
+    #region item cloning and persistence
     [StorableConstructor]
     private Solution(bool deserializing) : base(deserializing) { }
@@ -52,4 +53,5 @@
       return new Solution(this, cloner);
     }
+    #endregion
 
     public Solution(ISymbolicExpressionTree tree, int length, int width, double quality)